itpp::Base_Event Class Referenceabstract

Base Event Class. More...

`#include <itpp/protocol/events.h>`

Inheritance diagram for itpp::Base_Event:

## Public Member Functions

| Base_Event (const Ttype delta_time)
| Schedule an event at time `delta_time` from now.
virtual | ~Base_Event ()
| Destructor.
void | cancel ()
| Cancel an event.

## Protected Member Functions

virtual void | exec (void)=0
| ADD DOCUMENTATION HERE.

## Protected Attributes

Ttype | delta_t
| ADD DOCUMENTATION HERE.
Ttype | expire_t
| ADD DOCUMENTATION HERE.
bool | active
| ADD DOCUMENTATION HERE.
unsigned long long int | id
| ADD DOCUMENTATION HERE.

## Static Protected Attributes

static unsigned long long int | global_id = 0
| ADD DOCUMENTATION HERE.

## Friends

class | Base_Signal
class | Event_Queue
struct | Compare_Base_Event_Times

## Detailed Description

Base Event Class.

An abstract Base class of Events that can be used to derive new events. All Event classes need to define the exec() function which is called when the event expires. An event has an execution time and an id.

Definition at line 68 of file events.h.

## Constructor & Destructor Documentation

## Base_Event()

itpp::Base_Event::Base_Event | ( | const Ttype | delta_time | ) |

inline

Schedule an event at time `delta_time` from now.

Definition at line 78 of file events.h.

References active, delta_t, expire_t, global_id, and it_assert.

## ~Base_Event()

virtual itpp::Base_Event::~Base_Event | ( |  | ) |

inline virtual

Destructor.

Definition at line 87 of file events.h.

## Member Function Documentation

## cancel()

void itpp::Base_Event::cancel | ( |  | ) |

inline

Cancel an event.

Definition at line 90 of file events.h.

References active.

## exec()

virtual void itpp::Base_Event::exec | ( | void |  | ) |

protected pure virtual

ADD DOCUMENTATION HERE.

Implemented in itpp::Event< ObjectType >, itpp::Data_Event< ObjectType, DataType >, itpp::Data_Event< itpp::Signal, bool >, itpp::Data_Event< itpp::Signal, DataType >, itpp::Data_Event< itpp::Signal, double >, itpp::Data_Event< itpp::Signal, int >, itpp::Data_Event< itpp::Signal, itpp::ACK * >, itpp::Data_Event< itpp::Signal, itpp::Array< itpp::Packet * > >, itpp::Data_Event< itpp::Signal, itpp::Link_Packet * >, itpp::Data_Event< itpp::Signal, itpp::Packet * >, itpp::Data_Event< itpp::Signal, std::string >, and itpp::Data_Event< itpp::Signal, void * >.

## Friends And Related Symbol Documentation

## Base_Signal

friend class Base_Signal

friend

Definition at line 71 of file events.h.

## Event_Queue

friend class Event_Queue

friend

Definition at line 73 of file events.h.

## Compare_Base_Event_Times

friend struct Compare_Base_Event_Times

friend

Definition at line 75 of file events.h.

## Member Data Documentation

## delta_t

Ttype itpp::Base_Event::delta_t

protected

ADD DOCUMENTATION HERE.

Definition at line 96 of file events.h.

Referenced by itpp::Event_Queue::add(), and Base_Event().

## expire_t

Ttype itpp::Base_Event::expire_t

protected

ADD DOCUMENTATION HERE.

Definition at line 98 of file events.h.

Referenced by itpp::Event_Queue::add(), and Base_Event().

## active

bool itpp::Base_Event::active

protected

ADD DOCUMENTATION HERE.

Definition at line 100 of file events.h.

Referenced by Base_Event(), and cancel().

## id

unsigned long long int itpp::Base_Event::id

protected

ADD DOCUMENTATION HERE.

Definition at line 102 of file events.h.

## global_id

unsigned long long int itpp::Base_Event::global_id = 0

static protected

ADD DOCUMENTATION HERE.

Definition at line 104 of file events.h.

Referenced by Base_Event().

The documentation for this class was generated from the following files:

- itpp/protocol/events.h
- itpp/protocol/events.cpp

Generated on Mon Apr 22 2024 09:45:27 for IT++ by Doxygen 1.9.8